package com.ejie.ab79.dao.propuestaSancion;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.propuestaSancion.Derechos;

/****
 * 
 *  
 *
 */

@Repository
@Transactional
public class DerechosDaoImpl implements DerechosDao {

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */

	private RowMapper<Derechos> rwMap = new RowMapper<Derechos>() {
		public Derechos mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Derechos derechos = new Derechos();
			derechos.setIdDerecho(resultSet.getInt("IDDERECHO"));
			derechos.setArticulo(resultSet.getString("ARTICULO"));
			derechos.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			derechos.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));

			return derechos;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/**
	 * Finds a list of rows in the Derechos table.
	 *
	 * @param derechos
	 *            Derechos
	 *
	 * @return List<Derechos>
	 */
	@Transactional(readOnly = true)
	public List<Derechos> cargarCombo(Derechos filterDerechos) {
		StringBuilder query = new StringBuilder();
		List<Object> params = new ArrayList<Object>();

		query.append(
				"SELECT t08.ID_DERECHO IDDERECHO, t08.ARTICULO, t08.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t08.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA");
		query.append(" FROM DERECHOS t08");
		query.append(
				" WHERE ? IN (SELECT t17.ID_INFRACCION FROM AB59.REL_INF_DER t17 WHERE t08.ID_DERECHO = t17.ID_DERECHO)");
		params.add(filterDerechos.getInfraccion().getIdInfraccion());

		return (List<Derechos>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<Derechos> findDescripciones(String derechosString) {
		StringBuilder query = new StringBuilder();

		query.append(
				"SELECT t08.ID_DERECHO IDDERECHO, t08.ARTICULO, t08.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t08.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA");
		query.append(" FROM DERECHOS t08");
		query.append(" WHERE t08.ID_DERECHO IN (" + derechosString + ")");

		return (List<Derechos>) this.jdbcTemplate.query(query.toString(), this.rwMap);
	}
}